!/****************************************************************/
!/**                       DISLIN.F90                           **/
!/**                                                            **/
!/** Module file for DISLIN Fortran 90.                         **/
!/**                                                            **/
!/** Date     : 15.05.2001                                      **/
!/** Routines :      542                                        **/
!/** Version  :  7.5                                            **/
!/****************************************************************/
 
module dislin
public :: abs3pt, angle , arcell, areaf , autres, ax2grf, ax3len, axclrs
public :: axends, axgit , axis3d, axsbgd, axslen, axsorg, axspos, axsscl
public :: axstyp, bargrp, barpos, bars  , bartyp, barwth, basalf, bezier
public :: bitsi2, bitsi4, box2d , box3d , center, cgmbgd, cgmpic, cgmver
public :: chaang, chaspc, chawth, chnatt, chncrv, chndot, chndsh, chnpie
public :: circle, circsp, clip3d, closfl, clpbor, clpmod, clpwin, clrcyc
public :: clrmod, clswin, color , colran, colray, complx, concrv, congap
public :: conlab, conmat, conmod, conn3d, connpt, conpts, conshd, contur
public :: cross , crvmat, curv3d, curve , curve3, curvmp, curvx3, curvy3
public :: dash  , dashl , dashm , dattim,         disalf, disfin, disini
public :: dot   , dotl  , duplx , dwgbut, dwgfil, dwglis, dwgmsg, dwgtxt
public :: ellips, endgrf, erase , errbar, errdev, errfil, eushft, expzlb
public :: fcha  , field , filbox, filclr, filmod, fixspc, flab3d, flen  
public :: frame , frmess, gapcrv, getalf, getang, getbpp, getclp, getclr
public :: getdig, getdsp, getfil, getgrf, gethgt, getind, getlab, getlen
public :: getlev, getlin, getmat, getmfl, getmix, getor , getpag, getpat
public :: getplv, getpos, getran, getres, getrgb, getscl, getshf, getsp1
public :: getsp2, getsym, gettcl, gettic, gettyp, getuni, getver, getvk 
public :: getvlt, getwid, getwin, getxid, gmxalf, gothic, grace , graf  
public :: graf3 , graf3d, grafmp, grdpol, grffin, grfini, grid  , grid3d
public :: gridmp, gwgbox, gwgbut, gwgfil, gwglis, gwgscl, gwgtxt, height
public :: helve , helves, helvet, histog, hname , hsvrgb, hsymbl, htitle
public :: hwfont, hworig, hwpage, imgfin, imgini, inccrv, incfil, incmrk
public :: intax , intcha, intlen, itmcat, itmcnt, itmstr
public :: barbor, barclr, baropt, basdat, csrmov, csrpt1
public :: csrpts, csruni, incdat, barmod, gwgatt, gwgxid, getscr, getlit 
public :: labclr, labdig
public :: labdis, labels, labjus, labpos, labtyp, legclr, legend, legini
public :: leglin, legopt, legpat, legpos, legtit, lfttit, lincyc, line  
public :: linesp, lintyp, linwid, lncap , lnjoin, lnmlt , logtic, lsechk
public :: mapbas, maplev, mapmod, mappol, mapref, mapsph, marker, mdfmat
public :: messag, metafl, mixalf, mixleg, moment, mpaepl, mplang, mplclr
public :: mplpos, mplsiz, msgbox, mylab , myline, mypat , mypie , myvlt 
public :: namdis, name  , namjus, neglog, newmix, newpag, nlmess, nlnumb
public :: noarln, nobar , nobgd , nochek, noclip, nofill, nograf, nohide
public :: noline, number, numfmt, numode, nxlegn, nxposn, nylegn, nyposn
public :: nzposn, openfl, opnwin, origin, page  , pagera, pagfll, paghdr
public :: pagmod, patcyc, penwid, pie   , pieexp, piegrf, pielab, pievec
public :: point , polcrv, pos2pt, pos3pt, posifl, projct, psfont, readfl
public :: recfll, rectan, rel3pt, resatt, reset , revscr, rgbhsv, rgtlab
public :: rimage, rlarc , rlarea, rlcirc, rlconn, rlell , rline , rlmess
public :: rlnumb, rlpie , rlpoin, rlrec , rlrnd , rlsec , rlstrt, rlsymb
public :: rlvec , rndrec, rpixel, rpixls, rpxrow, rtiff , rvynam 
public :: sclfac, sclmod, scmplx, scrmod, sector, selwin, sendbf, sendok
public :: serif , setbas, setclr, setexp, setfil, setgrf, setind, setmix
public :: setpag, setres, setrgb, setscl, setvlt, setxid, shdcha, shdcrv
public :: shdeur, shdmap, shdmod, shdpat, shield, shlcir, shldel, shlell
public :: shlind, shlpie, shlpol, shlrct, shlrec, shlres, shlsur, shlvis
public :: simplx, skipfl, smxalf, solid , sortr1, sortr2, spline, splmod
public :: strt3d, strtpt, surclr, surfce,                 surmat, surmsh
public :: surshd, sursze, survis, swapi2, swapi4, swgbox, swgbut  
public :: swgfil, swgfnt, swghlp, swgjus, swglis, swgmix, swgmod, swgmrg
public :: swgoff, swgpop, swgpos, swgscl, swgsiz, swgtit, swgtxt, swgtyp
public :: swgwin, swgwth, symbol, symfil, symrot, tellfl, thkcrv, ticks 
public :: ticlen, ticpos, tiforg, tifwin, timopt, titjus, title , titlin
public :: titpos, trfco1, trfco2, trfco3, trfrel, trfres, trfrot, trfscl
public :: trfshf, triplx, trmlen, txtjus
public :: labmod, nwkday, piebor, pieclr, pieopt, pietyp, qplbar, qplcon
public :: qplot,  qplpie, qplsca, qplsur, qplclr, rpng  , suropt, ticmod
public :: trfdat, swgatt, swgdrw, swgopt, swgspc, sendmb, rbfpng
public :: light, litmod, litopt, litpos, matopt, mshclr, rppm, sphe3d
public :: suriso, texmod, texopt
public :: unit  , upstr , usrpie, vang3d
public :: vclp3d, vector, vectr3, vfoc3d, view3d, vkxbar, vkybar, vkytit
public :: vup3d , wgapp , wgbas , wgbox , wgbut , wgcmd , wgfil , wgfin 
public :: wgini , wglab , wglis , wgltxt, wgok  , wgpbut, wgpop , wgquit
public :: wgscl , wgtxt , widbar, wimage, winapp, window, winfnt, winid 
public :: winmod, winsiz, wintit, world , wpixel, wpixls, wpxrow, writfl
public :: wtiff , x11mod, x2dpos, x3dabs, x3dpos, x3drel, xaxgit, xaxis 
public :: xaxlg , xaxmap, xcross, xdraw , xinvrs, xmove , xposn , y2dpos
public :: y3dabs, y3dpos, y3drel, yaxgit, yaxis , yaxlg , yaxmap, ycross
public :: yinvrs, yposn , z3dpos, zaxis , zaxlg , zbffin, zbfini, zbflin
public :: zbftri, zscale, wgdlis, wgdraw
public :: circ3p, conclr, contri, crvtri, pdfmod, surtri, swgstp, triang
public :: winopt
!public :: surfcp, surfun, swgcb, swgcbk

   interface
      subroutine abs3pt(x,y,z,xp,yp)
        real, intent (in)  :: x,y,z
        real, intent (out) :: xp,yp
      end subroutine abs3pt

      subroutine angle(i)
        integer, intent (in) :: i
      end subroutine angle

      subroutine arcell(nx,ny,na,nb,alpha,beta,theta)
        integer, intent (in) :: nx,ny,na,nb
        real, intent (in)   :: alpha,beta,theta
      end subroutine arcell

      subroutine areaf(ix,iy,n)
        integer, dimension (:), intent (in) :: ix,iy
        integer, intent (in) :: n
      end subroutine areaf

      subroutine autres(i,j)
        integer, intent (in) :: i,j
      end subroutine autres

      subroutine ax2grf()
      end subroutine ax2grf

      subroutine ax3len(i,j,k)
        integer, intent (in) :: i,j,k
      end subroutine ax3len

      subroutine axclrs(n,copt,cax)
        integer, intent(in) :: n
        character (len = *) , intent (in) :: copt, cax
      end subroutine axclrs

      subroutine axends(copt,cax)
        character (len = *) , intent (in) :: copt, cax
      end subroutine axends

      subroutine axgit()
      end subroutine axgit

      subroutine axis3d(x,y,z)
        real, intent (in) :: x,y,z
      end subroutine axis3d

      subroutine axsbgd(n)
        integer, intent (in) :: n
      end subroutine axsbgd

      subroutine axslen(i,j)
        integer, intent (in) :: i,j
      end subroutine axslen

      subroutine axsorg(i,j)
        integer, intent (in) :: i,j
      end subroutine axsorg

      subroutine axspos(i,j)
        integer, intent (in) :: i,j
      end subroutine axspos

      subroutine axsscl(copt,cax)
        character (len = *), intent (in) :: copt,cax
      end subroutine axsscl

      subroutine axstyp(copt)
        character (len = *), intent (in) :: copt
      end subroutine axstyp

      subroutine barbor(iclr)
        integer, intent (in) :: iclr
      end subroutine barbor

      subroutine barclr(ic1,ic2,ic3)
        integer, intent (in) :: ic1,ic2,ic3
      end subroutine barclr

      subroutine bargrp(n,xgap)
        integer, intent (in) :: n
        real, intent (in) :: xgap
      end subroutine bargrp

      subroutine barmod(cmode,copt)
        character (len = *), intent (in) :: cmode,copt
      end subroutine barmod

      subroutine baropt(x1,x2)
        real, intent (in) :: x1,x2
      end subroutine baropt

      subroutine barpos(cpos)
        character (len = *), intent (in) :: cpos
      end subroutine barpos

      subroutine bars(xray,y1ray,y2ray,n)
        real, intent (in out), dimension (:) :: xray,y1ray,y2ray
        integer, intent (in) :: n
      end subroutine bars

      subroutine bartyp(ctyp)
        character (len = *), intent (in) :: ctyp
      end subroutine bartyp

      subroutine barwth(fact)
        real, intent (in) :: fact
      end subroutine barwth

      subroutine basalf(calph)
        character (len = *), intent (in) :: calph
      end subroutine basalf

      subroutine basdat(id,im,iy)
        integer, intent (in) :: id, im, iy
      end subroutine basdat

      subroutine bezier(xray,yray,nray,x,y,n)
        integer, intent (in)  :: nray,n
        real, dimension (:), intent (in)  :: xray, yray
        real, dimension (:), intent (out) :: x, y
      end subroutine bezier

      subroutine bitsi2(nbits,mher,iher,mhin,ihin,lob)
        integer, intent (in) :: nbits,iher,ihin,lob
!        integer (kind=selected_int_kind(4)), intent (in) :: mher
!        integer (kind=selected_int_kind(4)), intent (in out) :: mhin
        integer, intent (in) :: mher
        integer, intent (in out) :: mhin
      end subroutine bitsi2

      subroutine bitsi4(nbits,mher,iher,mhin,ihin,lob)
        integer, intent (in) :: nbits,mher,iher,ihin,lob
        integer, intent (in out) :: mhin
      end subroutine bitsi4

      subroutine box2d()
      end subroutine box2d

      subroutine box3d()
      end subroutine box3d

      subroutine center()
      end subroutine center

      subroutine cgmbgd(xr,xg,xb)
        real, intent (in) :: xr,xg,xb
      end subroutine cgmbgd

      subroutine cgmpic(ct)
        character (len = *), intent (in) :: ct
      end subroutine cgmpic

      subroutine cgmver(n)
        integer, intent (in) :: n
      end subroutine cgmver

      subroutine chaang(x)
        real, intent (in) :: x
      end subroutine chaang

      subroutine chaspc(x)
        real, intent (in) :: x
      end subroutine chaspc

      subroutine chawth(x)
        real, intent (in) :: x
      end subroutine chawth

      subroutine chnatt()
      end subroutine chnatt

      subroutine chncrv(copt)
        character (len = *), intent (in) :: copt
      end subroutine chncrv

      subroutine chndot()
      end subroutine chndot

      subroutine chndsh()
      end subroutine chndsh

      subroutine chnpie(copt)
        character (len = *), intent (in) :: copt
      end subroutine chnpie

      subroutine circ3p(x1,y1,x2,y2,x3,y3,xm,ym,r)
        real, intent (in) :: x1,y1,x2,y2,x3,y3
        real, intent (out) :: xm,ym,r
      end subroutine circ3p

      subroutine circle(nx,ny,nr)
        integer, intent (in) :: nx,ny,nr
      end subroutine circle

      subroutine circsp(n)
        integer, intent (in) :: n
      end subroutine circsp

      subroutine clip3d(ctyp)
        character (len = *), intent (in) :: ctyp
      end subroutine clip3d

      subroutine closfl(nlu)
        integer, intent (in) :: nlu
      end subroutine closfl

      subroutine clpbor(copt)
        character (len = *), intent (in) :: copt
      end subroutine clpbor

      subroutine clpmod(cmod)
        character (len = *), intent (in) :: cmod
      end subroutine clpmod

      subroutine clpwin(nx,ny,nw,nh)
        integer, intent (in) :: nx,ny,nw,nh
      end subroutine clpwin

      subroutine clrcyc(i,iclr)
        integer, intent (in) :: i,iclr
      end subroutine clrcyc

      subroutine clrmod(copt)
        character (len = *), intent (in) :: copt
      end subroutine clrmod

      subroutine clswin(id)
        integer, intent (in) :: id
      end subroutine clswin

      subroutine color(copt)
        character (len = *), intent (in) :: copt
      end subroutine color

      subroutine colran(i,j)
        integer, intent (in) :: i,j
      end subroutine colran

      subroutine colray(z,ncol,n)
        real, dimension (:), intent (in) :: z
        integer, dimension (:), intent (out) :: ncol
        integer, intent (in) :: n
      end subroutine colray

      subroutine complx()
      end subroutine complx

      subroutine conclr(iray,n)
        integer, dimension (:), intent (in) :: iray
        integer, intent (in) :: n
      end subroutine conclr

      subroutine concrv(x,y,n,zlev)
        real, dimension (:), intent (in) :: x,y
        integer, intent (in) :: n
        real, intent (in) :: zlev
      end subroutine concrv

      subroutine congap(xgap)
        real, intent (in) :: xgap
      end subroutine congap

      subroutine conlab(cstr)
        character (len = *), intent (in) :: cstr
      end subroutine conlab

      subroutine conmat(zmat,n,m,zlev)
        real, dimension (:,:), intent (in) :: zmat
        integer, intent (in) :: n,m
        real, intent (in) :: zlev
      end subroutine conmat

      subroutine conmod (xf1,xf2)
        real, intent (in) :: xf1,xf2
      end subroutine conmod

      subroutine conn3d(x2,y2,z2)
        real, intent (in) :: x2,y2,z2
      end subroutine conn3d

      subroutine connpt(x,y)
        real, intent (in) :: x,y
      end subroutine connpt

      subroutine conpts(x,n,y,m,z,zlev,xpts,ypts,maxpts,nray,maxray,nlins)
        real, dimension (:), intent (in) :: x,y
        real, dimension (:,:), intent (in) :: z
        integer, intent (in) :: n,m,maxpts,maxray
        real, intent (in) :: zlev
        integer, dimension (:), intent (out) :: nray
        integer, intent (out) :: nlins
        real, dimension (:), intent (out) :: xpts,ypts
      end subroutine conpts

      subroutine conshd(xray,n,yray,m,zmat,zlev,nlray)
        real, dimension (:), intent (in) :: xray,yray,zlev
        integer, intent (in) :: n,m,nlray
        real, dimension (:,:), intent (in) :: zmat
      end subroutine conshd

      subroutine contri(xray,yray,zray,n,i1ray,i2ray,i3ray,ntri,zlev)
        real, dimension (:), intent (in) :: xray,yray,zray
        integer, intent (in) :: n,ntri
        integer, dimension (:), intent (in) :: i1ray,i2ray,i3ray
        real, intent (in) :: zlev
      end subroutine contri

      subroutine contur(x,n,y,m,z,zlev)
        real, dimension (:), intent (in) :: x,y
        integer, intent (in) :: n,m
        real, dimension (:,:), intent (in) :: z
        real, intent (in) :: zlev
      end subroutine contur

      subroutine cross()
      end subroutine cross

      subroutine crvmat(zmat,ixdim,iydim,ixpts,iypts)
        real, dimension (:,:), intent (in) :: zmat
        integer, intent (in) :: ixdim,iydim,ixpts,iypts
      end subroutine crvmat

      subroutine crvtri(xray,yray,zray,n,i1ray,i2ray,i3ray,ntri)
        real, dimension (:), intent (in) :: xray,yray,zray
        integer, intent (in) :: n,ntri
        integer, dimension (:), intent (in) :: i1ray,i2ray,i3ray
      end subroutine crvtri

      subroutine csrpt1(ix,iy)
        integer, intent (out) :: ix,iy
      end subroutine csrpt1

      subroutine csrmov(ixray,iyray,nmax,n,iret)
        integer, dimension (:), intent (out) :: ixray,iyray
        integer, intent (out) :: n, iret
        integer, intent (in) :: nmax
      end subroutine csrmov

      subroutine csrpts(ixray,iyray,nmax,n,iret)
        integer, dimension (:), intent (out) :: ixray,iyray
        integer, intent (out) :: n, iret
        integer, intent (in) :: nmax
      end subroutine csrpts

      subroutine csruni(copt)
        character (len = *), intent (in) :: copt
      end subroutine csruni

      subroutine curv3d(x,y,z,n)
        real, dimension (:), intent (in) :: x,y,z
        integer, intent (in) :: n
      end subroutine curv3d

      subroutine curve(x,y,n)
        real, dimension (:), intent (in) :: x,y
        integer, intent (in) :: n
      end subroutine curve

      subroutine curve3(x,y,z,n)
        real, dimension (:), intent (in) :: x,y,z
        integer, intent (in) :: n
      end subroutine curve3

      subroutine curvmp(x,y,n)
        real, dimension (:), intent (in) :: x,y
        integer, intent (in) :: n
      end subroutine curvmp

      subroutine curvx3(x,y,z,n)
        real, dimension (:), intent (in) :: x,z
        real, intent (in) :: y
        integer, intent (in) :: n
      end subroutine curvx3

      subroutine curvy3(x,y,z,n)
        real, dimension (:), intent (in) :: y,z
        real, intent (in) :: x
        integer, intent (in) :: n
      end subroutine curvy3

      subroutine dash()
      end subroutine dash

      subroutine dashl()
      end subroutine dashl

      subroutine dashm()
      end subroutine dashm

      subroutine dattim(cdat,ctim)
        character (len = *), intent (out) :: cdat,ctim
      end subroutine dattim

      subroutine disalf()
      end subroutine disalf

      subroutine disfin()
      end subroutine disfin

      subroutine disini()
      end subroutine disini

      subroutine dot()
      end subroutine dot

      subroutine dotl()
      end subroutine dotl

      subroutine duplx()
      end subroutine duplx

      subroutine dwgbut(cstr,ival)
        character (len=*), intent (in) :: cstr
        integer, intent (in out) :: ival
      end subroutine dwgbut

      subroutine dwgfil(clab,cstr,cmask)
        character (len=*), intent (in) :: clab,cmask
        character (len=*), intent (in out) :: cstr
      end subroutine dwgfil

      subroutine dwglis(clab,clis,ilis)
        character (len=*), intent(in) :: clab,clis
        integer, intent (in out) :: ilis
      end subroutine dwglis

      subroutine dwgmsg(cstr)
        character (len=*), intent (in) :: cstr
      end subroutine dwgmsg

      subroutine dwgtxt(clab,cstr)
        character (len=*), intent(in) :: clab
        character (len=*), intent(in out) :: cstr
      end subroutine dwgtxt

      subroutine ellips(nx,ny,na,nb)
        integer, intent (in) :: nx,ny,na,nb
      end subroutine ellips

      subroutine endgrf()
      end subroutine endgrf

      subroutine erase()
      end subroutine erase

      subroutine errbar(x,y,err1,err2,n)
        real, dimension (:), intent (in) :: x,y,err1,err2
        integer, intent (in) :: n
      end subroutine errbar

      subroutine errdev(copt)
        character (len = *), intent (in) :: copt
      end subroutine errdev

      subroutine errfil(copt)
        character (len = *), intent (in) :: copt
      end subroutine errfil

      subroutine eushft(calph,csft)
        character (len = *), intent (in) :: calph,csft
      end subroutine eushft

      subroutine expzlb(copt)
        character (len = *), intent (in) :: copt
      end subroutine expzlb

      subroutine fcha(x,ndez,nl,cstr)
        real, intent (in) :: x
        integer, intent (in) :: ndez
        integer, intent (out) :: nl
        character (len = *), intent (out) :: cstr
      end subroutine fcha

      subroutine field(xray,yray,uray,vray,n,ivec)
        real, dimension (:), intent (in) :: xray,yray,uray,vray
        integer, intent (in) :: n,ivec
      end subroutine field

      subroutine filbox(nx,ny,nw,nh)
        integer, intent (in) :: nx,ny,nw,nh
      end subroutine filbox

      subroutine filclr(copt)
        character (len = *), intent (in) :: copt
      end subroutine filclr

      subroutine filmod(cmod)
        character (len = *), intent (in) :: cmod
      end subroutine filmod

      subroutine fixspc(x)
        real, intent (in) :: x
      end subroutine fixspc

      subroutine flab3d()
      end subroutine flab3d

      subroutine flen(x,ndez,nx)
        real, intent (in) :: x
        integer, intent (in) :: ndez
        integer, intent (out) :: nx
      end subroutine flen

      subroutine frame(i)
        integer, intent (in):: i
      end subroutine frame

      subroutine frmess(i)
        integer, intent (in):: i
      end subroutine frmess

      subroutine gapcrv(x)
        real, intent (in) :: x
      end subroutine gapcrv

      subroutine getalf(cstr)
        character (len = *), intent (out) :: cstr
      end subroutine getalf

      subroutine getang(i)
        integer, intent (out) :: i
      end subroutine getang

      subroutine getbpp(i)
        integer, intent (out) :: i
      end subroutine getbpp

      subroutine getclp(nx,ny,nw,nh)
        integer, intent (out) :: nx,ny,nw,nh
      end subroutine getclp

      subroutine getclr(i)
        integer, intent (out) :: i
      end subroutine getclr

      subroutine getdig(i,j,k)
        integer, intent (out) :: i,j,k
      end subroutine getdig

      subroutine getdsp(cdsp)
        character (len = *), intent (out) :: cdsp
      end subroutine getdsp

      subroutine getfil(cstr)
        character (len = *), intent (out) :: cstr
      end subroutine getfil

      subroutine getgrf(a,e,o,step,copt)
        real, intent (out) :: a,e,o,step
        character (len = *), intent (in) :: copt
      end subroutine getgrf

      subroutine gethgt(i)
        integer, intent (out) :: i
      end subroutine gethgt

      subroutine getind(i,xr,xg,xb)
        integer, intent (in) :: i
        real, intent (out) :: xr,xg,xb
      end subroutine getind

      subroutine getlab(c1,c2,c3)
        character (len = *), intent (out) :: c1,c2,c3
      end subroutine getlab

      subroutine getlen(i,j,k)
        integer, intent (out) :: i,j,k
      end subroutine getlen

      subroutine getlev(i)
        integer, intent (out) :: i
      end subroutine getlev

      subroutine getlin(i)
        integer, intent (out) :: i
      end subroutine getlin

      subroutine getlit(xp,yp,zp,xn,yn,zn,i)
        integer, intent (in) :: xp,yp,zp,xn,yn,zn
        integer, intent (out) :: i
      end subroutine getlit

      subroutine getmat(x,y,z,n,zmat,nx,ny,zval,imat,wmat)
        real, dimension (:), intent (in) :: x,y,z
        integer, intent (in) :: n,nx,ny
        real, dimension (:,:), intent (out) :: zmat
        real, intent (in) :: zval
        integer, dimension (:,:), intent (in out) :: imat
        real, dimension (:,:), intent (in out) :: wmat
      end subroutine getmat

      subroutine getmfl(cstr)
        character (len = *), intent (out) :: cstr
      end subroutine getmfl

      subroutine getmix(c,cstr)
        character (len = *), intent (out) :: c
        character (len = *), intent (in) :: cstr
      end subroutine getmix

      subroutine getor(i,j)
        integer, intent (out) :: i,j
      end subroutine getor

      subroutine getpag(i,j)
        integer, intent (out) :: i,j
      end subroutine getpag

      subroutine getpat(i)
        integer, intent (out) :: i
      end subroutine getpat

      subroutine getplv(i)
        integer, intent (out) :: i
      end subroutine getplv

      subroutine getpos(i,j)
        integer, intent (out) :: i,j
      end subroutine getpos

      subroutine getran(i,j)
        integer, intent (out) :: i,j
      end subroutine getran

      subroutine getres(i,j)
        integer, intent (out) :: i,j
      end subroutine getres

      subroutine getrgb(xr,xg,xb)
        real, intent (out) :: xr,xg,xb
      end subroutine getrgb

      subroutine getscl(i,j,k)
        integer, intent (out) :: i,j,k
      end subroutine getscl

      subroutine getscr(i,j)
        integer, intent (out) :: i,j
      end subroutine getscr

      subroutine getshf(cstr,c)
        character (len = *), intent (out) :: c
        character (len = *), intent (in) :: cstr
      end subroutine getshf

      subroutine getsp1(i,j,k)
        integer, intent (out) :: i,j,k
      end subroutine getsp1

      subroutine getsp2(i,j,k)
        integer, intent (out) :: i,j,k
      end subroutine getsp2

      subroutine getsym(i,j)
        integer, intent (out) :: i,j
      end subroutine getsym

      subroutine gettcl(i,j)
        integer, intent (out) :: i,j
      end subroutine gettcl

      subroutine gettic(i,j,k)
        integer, intent (out) :: i,j,k
      end subroutine gettic

      subroutine gettyp(i)
        integer, intent (out) :: i
      end subroutine gettyp

      subroutine getuni(i)
        integer, intent (out) :: i
      end subroutine getuni

      subroutine getver(xver)
        real, intent (out) :: xver
      end subroutine getver

      subroutine getvk(i,j,k)
        integer, intent (out) :: i,j,k
      end subroutine getvk

      subroutine getvlt(ctab)
        character (len = *), intent (out) :: ctab
      end subroutine getvlt

      subroutine getwid(i)
        integer, intent (out) :: i
      end subroutine getwid

      subroutine getwin(ix,iy,nw,nh)
        integer, intent (out) :: ix,iy,nw,nh
      end subroutine getwin

      subroutine getxid (ival, copt)
        integer, intent (out) :: ival
        character (len = *), intent (in) :: copt
      end subroutine getxid

      subroutine gmxalf(calph,ca,cb,n)
        character (len = *), intent (in) :: calph
        character (len = *), intent (out) :: ca,cb
        integer, intent (out) :: n
      end subroutine gmxalf

      subroutine gothic()
      end subroutine gothic

      subroutine grace(i)
        integer, intent (in) :: i
      end subroutine grace

      subroutine graf(ax,ex,orx,stepx,ay,ey,ory,stepy)
        real, intent (in) :: ax,ex,orx,stepx,ay,ey,ory,stepy
      end subroutine graf

      subroutine graf3(ax,ex,orx,stepx,ay,ey,ory,stepy,az,ez,orz,stepz)
        real, intent (in) :: ax,ex,orx,stepx,ay,ey,ory,stepy,az,ez,orz,stepz
      end subroutine graf3

      subroutine graf3d(ax,ex,orx,stepx,ay,ey,ory,stepy,az,ez,orz,stepz)
        real, intent (in) :: ax,ex,orx,stepx,ay,ey,ory,stepy,az,ez,orz,stepz
      end subroutine graf3d

      subroutine grafmp(ax,ex,orx,stepx,ay,ey,ory,stepy)
        real, intent (in) :: ax,ex,orx,stepx,ay,ey,ory,stepy
      end subroutine grafmp

      subroutine grdpol(igrd,jgrd)
        integer, intent (in) :: igrd,jgrd
      end subroutine grdpol

      subroutine grffin()
      end subroutine grffin

      subroutine grfini(x1,y1,z1,x2,y2,z2,x3,y3,z3)
        real, intent (in) :: x1,y1,z1,x2,y2,z2,x3,y3,z3
      end subroutine grfini

      subroutine grid(i,j)
        integer, intent (in) :: i,j
      end subroutine grid

      subroutine grid3d(igrid,jgrid,copt)
        integer, intent (in) :: igrid,jgrid
        character (len = *), intent (in) :: copt
      end subroutine grid3d

      subroutine gridmp(i,j)
        integer, intent (in) :: i,j
      end subroutine gridmp

      subroutine gwgatt (id,ival,copt)
        integer, intent (in) :: id
        integer, intent (out) :: ival
        character (len=*), intent (in) :: copt
      end subroutine gwgatt

      subroutine gwgbox(id,ival)
        integer, intent (in) :: id
        integer, intent (out) :: ival
      end subroutine gwgbox

      subroutine gwgbut(id,ival)
        integer, intent (in) :: id
        integer, intent (out) :: ival
      end subroutine gwgbut

      subroutine gwgfil(id,cstr)
        integer, intent (in) :: id
        character (len=*), intent (out) :: cstr
      end subroutine gwgfil

      subroutine gwglis(id,ival)
        integer, intent (in) :: id
        integer, intent (out) :: ival
      end subroutine gwglis

      subroutine gwgscl(id,xval)
        integer, intent (in) :: id
        real, intent (out) :: xval
      end subroutine gwgscl

      subroutine gwgtxt(id,cstr)
        integer, intent (in) :: id
        character (len=*), intent (out) :: cstr
      end subroutine gwgtxt

      subroutine gwgxid(id,ival)
        integer, intent (in) :: id
        integer, intent (out) :: ival
      end subroutine gwgxid

      subroutine height(i)
        integer, intent (in) :: i
      end subroutine height

      subroutine helve()
      end subroutine helve

      subroutine helves()
      end subroutine helves

      subroutine helvet()
      end subroutine helvet

      subroutine histog(xray,n,x,y,m)
        real, dimension (:), intent (in) :: xray
        integer, intent (in) :: n
        real, dimension (:), intent (out) :: x,y
        integer, intent (out) :: m
      end subroutine histog

      subroutine hname(i)
        integer, intent (in) :: i
      end subroutine hname

      subroutine hsvrgb(xh,xs,xv,r,g,b)
        real, intent (in)  :: xh,xs,xv
        real, intent (out) :: r,g,b
      end subroutine hsvrgb

      subroutine hsymbl(i)
        integer, intent (in) :: i
      end subroutine hsymbl

      subroutine htitle(i)
        integer, intent (in) :: i
      end subroutine htitle

      subroutine hwfont()
      end subroutine hwfont

      subroutine hworig(nx,ny)
        integer, intent (in) :: nx,ny
      end subroutine hworig

      subroutine hwpage(nxp,nyp)
        integer, intent (in) :: nxp,nyp
      end subroutine hwpage

      subroutine imgfin()
      end subroutine imgfin

      subroutine imgini()
      end subroutine imgini

      subroutine inccrv(i)
        integer, intent (in) :: i
      end subroutine inccrv

      function incdat(id,im,iy) result (iret)
        integer, intent (in) :: id, im, iy
        integer :: iret
      end function incdat

      subroutine incfil(cstr)
        character (len = *), intent (in) :: cstr
      end subroutine incfil

      subroutine incmrk(i)
        integer, intent (in) :: i
      end subroutine incmrk

      subroutine intax()
      end subroutine intax

      subroutine intcha(num,n,cnum)
        integer, intent (in)  :: num
        integer, intent (out) :: n
        character (len = *), intent (out) :: cnum
      end subroutine intcha

      subroutine intlen(nm,nlaen)
        integer, intent (in)  :: nm
        integer, intent (out) :: nlaen
      end subroutine intlen

      subroutine itmcat(clis,cstr)
        character (len=*), intent (in out) :: clis
        character (len=*), intent (in) :: cstr
      end subroutine itmcat

      function itmcnt(clis) result(iret)
        character (len=*), intent (in) :: clis
        integer :: iret
      end function itmcnt

      subroutine itmstr(clis,nlis,cstr)
        character (len=*), intent (in) :: clis
        character (len=*), intent (out) :: cstr
        integer, intent (in) :: nlis
      end subroutine itmstr

    subroutine labclr(iclr,copt)
      integer, intent (in) :: iclr
      character (len = *), intent (in) :: copt
    end subroutine labclr

    subroutine labdig(i,cax)
      integer, intent (in) :: i
      character (len = *), intent (in) :: cax
    end subroutine labdig

    subroutine labdis(i,cax)
      integer, intent (in) :: i
      character (len = *), intent (in) :: cax
    end subroutine labdis

    subroutine labels(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine labels

    subroutine labjus(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine labjus

    subroutine labmod(ckey,copt,cax)
      character (len = *), intent (in) :: ckey,copt,cax
    end subroutine labmod

    subroutine labpos(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine labpos

    subroutine labtyp(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine labtyp

    subroutine legclr()
    end subroutine legclr

    subroutine legend(cbf,ncor)
      character (len = *), intent (in) :: cbf
      integer, intent (in) :: ncor
    end subroutine legend

    subroutine legini(cbf,nlin,nmax)
      character (len = *), intent (in out) :: cbf
      integer, intent (in) :: nlin, nmax
    end subroutine legini

    subroutine leglin(cbf,cstr,n)
      character (len = *), intent (in out) :: cbf
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: n
    end subroutine leglin

    subroutine legopt(x1,x2,x3)
      real, intent (in) :: x1,x2,x3
    end subroutine legopt

    subroutine legpat(ilin,ithk,isym,iclr,ipat,i)
      integer, intent (in) :: ilin,ithk,isym,iclr,ipat,i
    end subroutine legpat

    subroutine legpos(nx,ny)
      integer, intent (in) :: nx,ny
    end subroutine legpos

    subroutine legtit(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine legtit

    subroutine lfttit()
    end subroutine lfttit

    subroutine lincyc(i,ilin)
      integer, intent (in) :: i,ilin
    end subroutine lincyc

    subroutine line(nx,ny,nu,nv)
      integer, intent (in) :: nx,ny,nu,nv
    end subroutine line

    subroutine linesp(x)
      real, intent (in) :: x
    end subroutine linesp

    subroutine lintyp(i)
      integer, intent (in) :: i
    end subroutine lintyp

    subroutine linwid(i)
      integer, intent (in) :: i
    end subroutine linwid

    subroutine light(copt)
      character (len = *), intent (in) :: copt
    end subroutine light

    subroutine litmod(id,copt)
      integer, intent (in) :: id
      character (len = *), intent (in) :: copt
    end subroutine litmod

    subroutine litopt(id,x,copt)
      integer, intent (in) :: id
      real, intent (in) :: x
      character (len = *), intent (in) :: copt
    end subroutine litopt
 
    subroutine litpos(id,xp,yp,zp,copt)
      integer, intent (in) :: id
      real, intent (in) :: xp,yp,zp
      character (len = *), intent (in) :: copt
    end subroutine litpos

    subroutine lncap(copt)
      character (len = *), intent (in) :: copt
    end subroutine lncap

    subroutine lnjoin(copt)
      character (len = *), intent (in) :: copt
    end subroutine lnjoin

    subroutine lnmlt(x)
      real, intent (in) :: x
    end subroutine lnmlt

    subroutine logtic(copt)
      character (len = *), intent (in) :: copt
    end subroutine logtic

    subroutine lsechk(copt)
      character (len = *), intent (in) :: copt
    end subroutine lsechk

    subroutine mapbas(copt)
      character (len = *), intent (in) :: copt
    end subroutine mapbas
 
    subroutine maplev(copt)
      character (len = *), intent (in) :: copt
    end subroutine maplev
 
    subroutine mapmod(copt)
      character (len = *), intent (in) :: copt
    end subroutine mapmod
 
    subroutine mappol(x,y)
      real, intent (in) :: x,y
    end subroutine mappol
 
    subroutine mapref(ylw,yup)
      real, intent (in) :: ylw,yup
    end subroutine mapref
 
    subroutine mapsph(xrad)
      real, intent (in) :: xrad
    end subroutine mapsph
 
    subroutine marker(i)
      integer, intent (in) :: i
    end subroutine marker
 
    subroutine matopt(x,copt)
      real, intent (in) :: x
      character (len = *), intent (in) :: copt
    end subroutine matopt

    subroutine mdfmat(i,j,x)
      integer, intent (in) :: i,j
      real, intent (in) :: x
    end subroutine mdfmat
 
    subroutine messag(cstr,nx,ny)
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: nx,ny
    end subroutine messag
 
    subroutine metafl(ct)
      character (len = *), intent (in) :: ct
    end subroutine metafl
 
    subroutine mixalf()
    end subroutine mixalf
 
    subroutine mixleg()
    end subroutine mixleg
 
    subroutine moment(xray,n,copt,xv)
      real, dimension (:), intent (in) :: xray
      integer, intent (in) :: n
      character (len = *), intent (in) :: copt
      real, intent (out) :: xv
    end subroutine moment
 
    subroutine mpaepl(i)
      integer, intent (in) :: i
    end subroutine mpaepl
 
    subroutine mplang(x)
      real, intent (in) :: x
    end subroutine mplang
 
    subroutine mplclr(i,j)
      integer, intent (in) :: i,j
    end subroutine mplclr
 
    subroutine mplpos(i,j)
      integer, intent (in) :: i,j
    end subroutine mplpos
 
    subroutine mplsiz(i)
      integer, intent (in) :: i
    end subroutine mplsiz
 
    subroutine msgbox(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine msgbox
 
    subroutine mshclr(ic)
      integer, intent (in) :: ic
    end subroutine mshclr

    subroutine mylab(cstr,i,cax)
      character (len = *), intent (in) :: cstr,cax
      integer, intent (in) :: i
    end subroutine mylab
 
    subroutine myline(nray,n)
      integer, dimension (:), intent (in) :: nray
      integer, intent (in) :: n
    end subroutine myline
 
    subroutine mypat(iang,itype,idens,icross)
      integer, intent (in) :: iang,itype,idens,icross
    end subroutine mypat
 
    subroutine mypie(iseg,xdat,xper,nrad,noff,ang,nvbox,idrw,iann)
      integer, intent (in out) :: iseg,nrad,noff,nvbox,idrw,iann
      real, intent (in out)    :: xdat,xper,ang
    end subroutine mypie
 
    subroutine myvlt(xr,xg,xb,n)
      real, dimension (:), intent (in) :: xr,xg,xb
      integer, intent (in) :: n
    end subroutine myvlt
 
    subroutine namdis(i,cax)
      integer, intent (in) :: i
      character (len = *), intent (in) :: cax
    end subroutine namdis
 
    subroutine name(cnam,cax)
      character (len = *), intent (in) :: cnam,cax
    end subroutine name
 
    subroutine namjus(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine namjus
 
    subroutine neglog(e)
      real, intent (in) :: e
    end subroutine neglog
 
    subroutine newmix()
    end subroutine newmix
 
    subroutine newpag()
    end subroutine newpag
 
    function nlmess(cstr) result(iret)
      character (len = *), intent (in) :: cstr
      integer :: iret
    end function nlmess
 
    function nlnumb(x,ndez) result (iret)
      real, intent (in) :: x
      integer, intent (in) :: ndez
      integer :: iret
    end function nlnumb
 
    subroutine noarln()
    end subroutine noarln
 
    subroutine nobar()
    end subroutine nobar
 
    subroutine nobgd()
    end subroutine nobgd
 
    subroutine nochek()
    end subroutine nochek
 
    subroutine noclip()
    end subroutine noclip
 
    subroutine nofill()
    end subroutine nofill
 
    subroutine nograf()
    end subroutine nograf
 
    subroutine nohide()
    end subroutine nohide
 
    subroutine noline(cax)
      character (len = *), intent (in) :: cax
    end subroutine noline
 
    subroutine number(x,ndez,nx,ny)
      real, intent (in) :: x
      integer, intent (in) :: ndez,nx,ny
    end subroutine number
 
    subroutine numfmt(ct)
      character (len = *), intent (in) :: ct
    end subroutine numfmt
 
    subroutine numode(cdec,cgrp,cpos,cspc)
      character (len = *), intent (in) :: cdec,cgrp,cpos,cspc
    end subroutine numode

    function nwkday(id,im,iy) result (iret)
      integer, intent (in) :: id,im,iy
      integer :: iret
    end function nwkday
 
    function nxlegn(cbf) result (iret)
      character (len = *), intent (in) :: cbf
      integer :: iret
    end function nxlegn
 
    function nxposn(x) result (iret)
      real, intent (in) :: x
      integer :: iret
    end function nxposn
 
    function nylegn(cbf) result (iret)
      character (len = *), intent (in) :: cbf
      integer :: iret
    end function nylegn
 
    function nyposn(y) result (iret)
      real, intent (in) :: y
      integer :: iret
    end function nyposn
 
    function nzposn(z) result (iret)
      real, intent (in) :: z
      integer :: iret
    end function nzposn
 
    subroutine openfl(cstr,nlu,irw,istat)
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: nlu,irw
      integer, intent (out) :: istat
    end subroutine openfl
 
    subroutine opnwin(id)
      integer, intent (in) :: id
    end subroutine opnwin
 
    subroutine origin(i,j)
      integer, intent (in) :: i,j
    end subroutine origin
 
    subroutine page(nxp,nyp)
      integer, intent (in) :: nxp,nyp
    end subroutine page
 
    subroutine pagera()
    end subroutine pagera
 
    subroutine pagfll(n)
      integer, intent (in) :: n
    end subroutine pagfll
 
    subroutine paghdr(c1,c2,iopt,idir)
      character (len = *), intent (in) :: c1,c2
      integer, intent (in) :: iopt,idir
    end subroutine paghdr
 
    subroutine pagmod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine pagmod
 
    subroutine patcyc(i,ipat)
      integer, intent (in) :: i,ipat
    end subroutine patcyc
 
    subroutine pdfmod(cmod,ckey)
      character (len = *), intent (in) :: cmod,ckey
    end subroutine pdfmod

    subroutine penwid(x)
      real, intent (in) :: x
    end subroutine penwid
 
    subroutine pie(nx,ny,nr,a,b)
      integer, intent (in) :: nx,ny,nr
      real, intent (in) :: a,b
    end subroutine pie

    subroutine piebor(iclr)
      integer, intent (in) :: iclr
    end subroutine piebor

    subroutine pieclr(ic1,ic2,n)
      integer, dimension (:), intent (in) :: ic1,ic2
      integer, intent (in) :: n
    end subroutine pieclr
 
    subroutine pieexp()
    end subroutine pieexp
 
    subroutine piegrf(cstr,nlin,xray,n)
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: nlin,n
      real, dimension (:), intent (in) :: xray
    end subroutine piegrf
 
    subroutine pielab(cdat,cstr)
      character(len = *), intent (in) :: cdat,cstr
    end subroutine pielab

    subroutine pieopt(x1,x2)
      real, intent (in) :: x1,x2
    end subroutine pieopt

    subroutine pietyp(ctyp)
      character (len = *), intent (in) :: ctyp
    end subroutine pietyp
 
    subroutine pievec(ivec,copt)
      integer, intent (in) :: ivec
      character (len = *), intent (in) :: copt
    end subroutine pievec
 
    subroutine point(nx,ny,nb,nh,ncol)
      integer, intent (in) :: nx,ny,nb,nh,ncol
    end subroutine point
 
    subroutine polcrv(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine polcrv
 
    subroutine pos2pt(x,y,xp,yp)
      real, intent (in) :: x,y
      real, intent (out) :: xp,yp
    end subroutine pos2pt
 
    subroutine pos3pt(x,y,z,xp,yp,zp)
      real, intent (in) :: x,y,z
      real, intent (out) :: xp,yp,zp
    end subroutine pos3pt
 
    subroutine posifl(nlu,nbyt,istat)
      integer, intent (in) :: nlu,nbyt
      integer, intent (out) :: istat
    end subroutine posifl
 
    subroutine projct(copt)
      character (len = *), intent (in) :: copt
    end subroutine projct
 
    subroutine psfont(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine psfont
 
    subroutine qplbar(x,n)
      real, dimension (:), intent (in) :: x
      integer, intent (in) :: n
    end subroutine qplbar

    subroutine qplclr(x,n,m)
      real, dimension (:,:), intent (in) :: x
      integer, intent (in) :: n,m
    end subroutine qplclr

    subroutine qplcon(x,n,m,nlev)
      real, dimension (:,:), intent (in) :: x
      integer, intent (in) :: n,m,nlev
    end subroutine qplcon

    subroutine qplot(x,y,n)
      real, dimension (:), intent (in) :: x,y
      integer, intent (in) :: n
    end subroutine qplot

    subroutine qplpie(x,n)
      real, dimension (:), intent (in) :: x
      integer, intent (in) :: n
    end subroutine qplpie

    subroutine qplsca(x,y,n)
      real, dimension (:), intent (in) :: x,y
      integer, intent (in) :: n
    end subroutine qplsca

    subroutine qplsur(x,n,m)
      real, dimension (:,:), intent (in) :: x
      integer, intent (in) :: n,m
    end subroutine qplsur

    subroutine rbfpng(iray,nmax,nn)
      character (len=*), intent (out), dimension (:) :: iray
      integer, intent (in) :: nmax
      integer, intent (out) :: nn
    end subroutine rbfpng

    subroutine readfl(nlu,iray,nbyt,istat)
      character (len=*), intent (out), dimension (:) :: iray
      integer, intent (in) :: nlu,nbyt
      integer, intent (out) :: istat
    end subroutine readfl
 
    subroutine recfll(nx,ny,nb,nh,ncol)
      integer, intent (in) :: nx,ny,nb,nh,ncol
    end subroutine recfll
 
    subroutine rectan(nx,ny,nb,nh)
      integer, intent (in) :: nx,ny,nb,nh
    end subroutine rectan
 
    subroutine rel3pt(x,y,z,xp,yp)
      real, intent (in) :: x,y,z
      real, intent (out) :: xp,yp
    end subroutine rel3pt
 
    subroutine resatt()
    end subroutine resatt
 
    subroutine reset(cw)
      character (len = *), intent (in) :: cw
    end subroutine reset
 
    subroutine revscr()
    end subroutine revscr
 
    subroutine rgbhsv(r,g,b,xh,xs,xv)
      real, intent (in) :: r,g,b
      real, intent (out) :: xh,xs,xv
    end subroutine rgbhsv
 
    subroutine rgtlab()
    end subroutine rgtlab
 
    subroutine rimage(cfl)
      character (len = *), intent (in) :: cfl
    end subroutine rimage
 
    subroutine rlarc(xm,ym,a,b,alpha,beta,theta)
      real, intent (in) :: xm,ym,a,b,alpha,beta,theta
    end subroutine rlarc
 
    subroutine rlarea(x,y,n)
      real, dimension (:), intent (in) :: x,y
      integer, intent (in) :: n
    end subroutine rlarea
 
    subroutine rlcirc(xm,ym,r)
      real, intent (in) :: xm,ym,r
    end subroutine rlcirc
 
    subroutine rlconn(x,y)
      real, intent (in) :: x,y
    end subroutine rlconn
 
    subroutine rlell(xm,ym,a,b)
      real, intent (in) :: xm,ym,a,b
    end subroutine rlell
 
    subroutine rline(x,y,u,v)
      real, intent (in) :: x,y,u,v
    end subroutine rline
 
    subroutine rlmess(cstr,x,y)
      character (len = *), intent (in) :: cstr
      real, intent (in) :: x,y
    end subroutine rlmess
 
    subroutine rlnumb(z,ndez,x,y)
      real, intent (in) :: z,x,y
      integer, intent (in) :: ndez
    end subroutine rlnumb
 
    subroutine rlpie(xm,ym,r,alpha,beta)
      real, intent (in) :: xm,ym,r,alpha,beta
    end subroutine rlpie
 
    subroutine rlpoin(x,y,nb,nh,ncol)
      real, intent (in) :: x,y
      integer, intent (in) :: nb,nh,ncol
    end subroutine rlpoin
 
    subroutine rlrec(x,y,xb,xh)
      real, intent (in) :: x,y,xb,xh
    end subroutine rlrec
 
    subroutine rlrnd(x,y,xb,xh,irnd)
      real, intent (in) :: x,y,xb,xh
      integer, intent (in) :: irnd
    end subroutine rlrnd
 
    subroutine rlsec(xm,ym,r1,r,beta,alpha,ncol)
      real, intent (in) :: xm,ym,r1,r,beta,alpha
      integer, intent (in) :: ncol
    end subroutine rlsec
 
    subroutine rlstrt(x,y)
      real, intent (in) :: x,y
    end subroutine rlstrt
 
    subroutine rlsymb(i,x,y)
      integer, intent (in) :: i
      real, intent (in) :: x,y
    end subroutine rlsymb
 
    subroutine rlvec(x,y,u,v,ivec)
      real, intent (in) :: x,y,u,v
      integer, intent (in) :: ivec
    end subroutine rlvec
 
    subroutine rndrec(nx,ny,nb,nh,irnd)
      integer, intent (in) :: nx,ny,nb,nh,irnd
    end subroutine rndrec
 
    subroutine rpixel(ix,iy,n)
      integer, intent (in)  :: ix,iy
      integer, intent (out) :: n
    end subroutine rpixel
 
    subroutine rpixls(iray,ix,iy,nw,nh)
      character (len=*), intent (out), dimension (:) :: iray
      integer, intent (in) :: ix,iy,nw,nh
    end subroutine rpixls

    subroutine rpng(cfl)
      character (len=*), intent (in) :: cfl
    end subroutine rpng
 
    subroutine rppm(cfl)
      character (len=*), intent (in) :: cfl
    end subroutine rppm
 
    subroutine rpxrow(iray,ix,iy,n)
      character (len=*), intent (out), dimension (:) :: iray
      integer, intent (in) :: ix,iy,n
    end subroutine rpxrow
 
    subroutine rtiff(cfl)
      character (len=*), intent (in) :: cfl
    end subroutine rtiff
 
    subroutine rvynam()
    end subroutine rvynam
 
!    subroutine scale(copt,cax)
!      character (len = *), intent (in) :: copt,cax
!    end subroutine scale
 
    subroutine sclfac(x)
      real, intent (in) :: x
    end subroutine sclfac
 
    subroutine sclmod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine sclmod
 
    subroutine scmplx()
    end subroutine scmplx
 
    subroutine scrmod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine scrmod
 
    subroutine sector(nx,ny,nr1,nr2,alpha,beta,ncol)
      integer, intent (in) :: nx,ny,nr1,nr2,ncol
      real, intent (in) :: alpha,beta
    end subroutine sector
 
    subroutine selwin(id)
      integer, intent (in) :: id
    end subroutine selwin
 
    subroutine sendbf()
    end subroutine sendbf
 
    subroutine sendok()
    end subroutine sendok

    subroutine sendmb()
    end subroutine sendmb
 
    subroutine serif()
    end subroutine serif
 
    subroutine setbas(f)
      real, intent (in) :: f
    end subroutine setbas
 
    subroutine setclr(n)
      integer, intent (in) :: n
    end subroutine setclr
 
    subroutine setexp(f)
      real, intent (in) :: f
    end subroutine setexp
 
    subroutine setfil(ct)
      character (len = *), intent (in) :: ct
    end subroutine setfil
 
    subroutine setgrf(c1,c2,c3,c4)
      character (len = *), intent (in) :: c1,c2,c3,c4
    end subroutine setgrf
 
    subroutine setind(i,xr,xg,xb)
      integer, intent (in) :: i
      real, intent (in) :: xr,xg,xb
    end subroutine setind
 
    subroutine setmix(c,cstr)
      character (len = *), intent (in) :: c,cstr
    end subroutine setmix
 
    subroutine setpag(ct)
      character (len = *), intent (in) :: ct
    end subroutine setpag
 
    subroutine setres(i,j)
      integer, intent (in) :: i,j
    end subroutine setres
 
    subroutine setrgb(xr,xg,xb)
      real, intent (in) :: xr,xg,xb
    end subroutine setrgb
 
    subroutine setscl(xray,n,cstr)
      real, dimension (:), intent (in) :: xray
      integer, intent (in) :: n
      character (len = *), intent (in) :: cstr
    end subroutine setscl
 
    subroutine setvlt(ctab)
      character (len = *), intent (in) :: ctab
    end subroutine setvlt
 
    subroutine setxid(i,copt)
      integer, intent (in) :: i
      character (len = *), intent (in) :: copt
    end subroutine setxid
 
    subroutine shdcha()
    end subroutine shdcha
 
    subroutine shdcrv(x1,y1,n1,x2,y2,n2)
      real, dimension (:), intent (in) :: x1,y1,x2,y2
      integer, intent (in) :: n1,n2
    end subroutine shdcrv
 
    subroutine shdeur(inat,ishd,iclr,n)
      integer, dimension (:), intent (in) :: inat,ishd,iclr
      integer, intent (in) :: n
    end subroutine shdeur
 
    subroutine shdmap(cmap)
      character (len = *), intent (in) :: cmap
    end subroutine shdmap
 
    subroutine shdmod(copt,ctype)
      character (len = *), intent (in) :: copt,ctype
    end subroutine shdmod
 
    subroutine shdpat(i)
      integer, intent (in) :: i
    end subroutine shdpat
 
    subroutine shield(cblnk,cmode)
      character (len = *), intent (in) :: cblnk,cmode
    end subroutine shield
 
    subroutine shlcir(nx,ny,nr)
      integer, intent (in) :: nx,ny,nr
    end subroutine shlcir
 
    subroutine shldel(id)
      integer, intent (in) :: id
    end subroutine shldel
 
    subroutine shlell(nx,ny,na,nb,ang)
      integer, intent (in) :: nx,ny,na,nb
      real, intent (in) :: ang
    end subroutine shlell
 
    subroutine shlind(id)
      integer, intent (out) :: id
    end subroutine shlind
 
    subroutine shlpie(nx,ny,nr,alph,beta)
      integer, intent (in) :: nx,ny,nr
      real, intent (in) :: alph,beta
    end subroutine shlpie
 
    subroutine shlpol(nxray,nyray,n)
      integer, dimension (:), intent (in) :: nxray,nyray
      integer, intent (in) :: n
    end subroutine shlpol
 
    subroutine shlrct(nx,ny,nw,nh,ang)
      integer, intent (in) :: nx,ny,nw,nh
      real,    intent (in) :: ang
    end subroutine shlrct
 
    subroutine shlrec(nx,ny,nw,nh)
      integer, intent (in) :: nx,ny,nw,nh
    end subroutine shlrec
 
    subroutine shlres(nn)
      integer, intent (in) :: nn
    end subroutine shlres
 
    subroutine shlsur()
    end subroutine shlsur
 
    subroutine shlvis(id,cvis)
      integer, intent (in) :: id
      character (len = *), intent (in) :: cvis
    end subroutine shlvis
 
    subroutine simplx()
    end subroutine simplx
 
    subroutine skipfl(nlu,nbyt,istat)
      integer, intent (in) :: nlu,nbyt
      integer, intent (out) :: istat
    end subroutine skipfl
 
    subroutine smxalf(calph,ca,cb,n)
      character (len = *), intent (in) :: calph,ca,cb
      integer, intent (in) :: n
    end subroutine smxalf
 
    subroutine solid()
    end subroutine solid
 
    subroutine sortr1(x,n,copt)
      real, dimension (:), intent (in out) :: x
      integer, intent (in) :: n
      character (len = *), intent (in) :: copt
    end subroutine sortr1
 
    subroutine sortr2(x,y,n,copt)
      integer, intent (in) :: n
      real, dimension (:), intent (in out) :: x,y
      character (len = *), intent (in) :: copt
    end subroutine sortr2
 
    subroutine sphe3d(xm,ym,zm,r,nsk1,nsk2)
      real, intent (in) :: xm,ym,zm,r
      integer, intent (in) :: nsk1,nsk2
    end subroutine sphe3d
 
    subroutine spline(x,y,n,xray,yray,ndat)
      real, dimension (:),intent (in) :: x,y
      integer, intent (in) :: n
      real, dimension (:),intent (out) :: xray,yray
      integer, intent (out) :: ndat
    end subroutine spline
 
    subroutine splmod(k,n)
      integer, intent (in) :: k,n
    end subroutine splmod
 
    subroutine strt3d(x,y,z)
      real, intent (in) :: x,y,z
    end subroutine strt3d
 
    subroutine strtpt(x,y)
      real, intent (in) :: x,y
    end subroutine strtpt
 
    subroutine surclr(itop,ibot)
      integer, intent (in) :: itop,ibot
    end subroutine surclr
 
    subroutine surfce(xray,ixdim,yray,iydim,zmat)
      real, dimension (:), intent (in) :: xray,yray
      integer, intent (in) :: ixdim,iydim
      real, dimension (:,:), intent (in) :: zmat
    end subroutine surfce
 
!    subroutine surfcp(zfun,a1,a2,astp,b1,b2,bstp)
!      interface
!         function zfun(x,y,iopt)
!           real, intent (in) :: x,y
!           integer, intent (in) :: iopt
!           real :: zfun
!         end function zfun
!      end interface
!      real, intent (in) :: a1,a2,astp,b1,b2,bstp
!    end subroutine surfcp
 
!    subroutine surfun(zfun,ixpts,xdel,iypts,ydel)
!      interface
!         function zfun(x,y)
!           real, intent (in) :: x,y
!           real :: zfun
!         end function zfun
!      end interface
!      integer, intent (in) :: ixpts,iypts
!      real, intent (in) :: xdel,ydel
!    end subroutine surfun
 
    subroutine suriso(xray,nx,yray,ny,zray,nz,wmat,wlev)
      real, dimension (:), intent (in) :: xray,yray,zray
      integer, intent (in) :: nx,ny,nz
      real, dimension (:,:,:), intent (in) :: wmat
      real, intent (in) :: wlev
    end subroutine suriso

    subroutine surmat(zmat,ixdim,iydim,ixp,iyp)
      integer, intent (in) :: ixdim,iydim,ixp,iyp
      real, dimension (:,:), intent (in) :: zmat
    end subroutine surmat
 
    subroutine surmsh(copt)
      character (len = *), intent (in) :: copt
    end subroutine surmsh
 
    subroutine suropt(copt)
      character (len = *), intent (in) :: copt
    end subroutine suropt

    subroutine surshd(xray,ixdim,yray,iydim,zmat)
      real, dimension (:), intent (in) :: xray,yray
      integer, intent (in) :: ixdim,iydim
      real, dimension (:,:), intent (in) :: zmat
    end subroutine surshd
 
    subroutine sursze(ax,ex,ay,ey)
      real, intent (in) :: ax,ex,ay,ey
    end subroutine sursze

    subroutine surtri(xray,yray,zray,n,i1ray,i2ray,i3ray,ntri)
      real, dimension (:), intent (in) :: xray,yray,zray
      integer, intent (in) :: n,ntri
      integer, dimension (:), intent (in) :: i1ray,i2ray,i3ray
    end subroutine surtri
 
    subroutine survis(copt)
      character (len = *), intent (in) :: copt
    end subroutine survis
 
    subroutine swapi2(iray,n)
!      integer (kind=selected_int_kind(4)), dimension (:), &
!              intent (in out) :: iray
      integer, dimension (:), intent (in out) :: iray
      integer, intent (in) :: n
    end subroutine swapi2
 
    subroutine swapi4(iray,n)
      integer, dimension (:), intent (in out) :: iray
      integer, intent (in) :: n
    end subroutine swapi4
 
    subroutine swgatt (id,cval,copt)
      integer, intent (in) :: id
      character (len=*), intent (in) :: cval,copt
    end subroutine swgatt

    subroutine swgbox(id,ival)
      integer, intent (in) :: id,ival
    end subroutine swgbox
 
    subroutine swgbut(id,ival)
      integer, intent (in) :: id,ival
    end subroutine swgbut
 
!    subroutine swgcb (id, callbk, iray)
!      integer, intent (in) :: id
!      integer, dimension (:), intent (in) :: iray
! 
!      interface
!         subroutine callbk (id,iray)
!           integer, intent (in) :: id
!           integer, dimension (:), intent (in) :: iray
!         end subroutine callbk
!      end interface
!    end subroutine swgcb
 
    subroutine swgdrw(x)
      real, intent (in) :: x
    end subroutine swgdrw

    subroutine swgfil(id,cstr)
      integer, intent (in) :: id
      character (len=*), intent (in) :: cstr
    end subroutine swgfil
 
    subroutine swgfnt(cstr,n)
      character (len=*), intent (in) :: cstr
      integer, intent (in) :: n
    end subroutine swgfnt
 
    subroutine swghlp(cstr)
      character (len=*), intent (in) :: cstr
    end subroutine swghlp
 
    subroutine swgjus (ctype,cwidg)
      character (len=*), intent (in) :: ctype,cwidg
    end subroutine swgjus
 
    subroutine swglis(id,ival)
      integer, intent (in) :: id,ival
    end subroutine swglis
 
    subroutine swgmix(c,cstr)
      character (len=*), intent (in) :: c,cstr
    end subroutine swgmix
 
    subroutine swgmod(cmod)
      character (len=*), intent (in) :: cmod
    end subroutine swgmod
 
    subroutine swgmrg(ival,cstr)
      integer, intent (in) :: ival
      character (len=*), intent (in) :: cstr
    end subroutine swgmrg
 
    subroutine swgoff(nx,ny)
      integer, intent (in) :: nx,ny
    end subroutine swgoff

    subroutine swgopt (cval,copt)
      character (len=*), intent (in) :: cval,copt
    end subroutine swgopt
 
    subroutine swgpop (copt)
      character (len=*), intent (in) :: copt
    end subroutine swgpop
 
    subroutine swgpos(nx,ny)
      integer, intent (in) :: nx,ny
    end subroutine swgpos
 
    subroutine swgscl(id,xval)
      integer, intent (in) :: id
      real, intent (in) :: xval
    end subroutine swgscl
 
    subroutine swgsiz(nx,ny)
      integer, intent (in) :: nx,ny
    end subroutine swgsiz

    subroutine swgspc(x, y)
      real, intent (in) :: x,y
    end subroutine swgspc
 
    subroutine swgstp(x)
      real, intent (in) :: x
    end subroutine swgstp

    subroutine swgtit(cstr)
      character (len=*), intent (in) :: cstr
    end subroutine swgtit
 
    subroutine swgtxt(id,cstr)
      integer, intent (in) :: id
      character (len=*), intent (in) :: cstr
    end subroutine swgtxt
 
    subroutine swgtyp (ctype,cwidg)
      character (len=*), intent (in) :: ctype,cwidg
    end subroutine swgtyp
 
    subroutine swgwin(nx,ny,nw,nh)
      integer, intent (in) :: nx,ny,nw,nh
    end subroutine swgwin
 
    subroutine swgwth (nwth)
      integer, intent (in) :: nwth
    end subroutine swgwth
 
    subroutine symbol(i,nx,ny)
      integer, intent (in) :: i,nx,ny
    end subroutine symbol
 
    subroutine symfil(cdv,cst)
      character (len=*), intent (in) :: cdv,cst
    end subroutine symfil
 
    subroutine symrot(xrot)
      real, intent (in) :: xrot
    end subroutine symrot
 
    subroutine tellfl(nlu,nbyt)
      integer, intent (in) :: nlu
      integer, intent (out) :: nbyt
    end subroutine tellfl

    subroutine texmod(copt)
      character (len = *), intent (in) :: copt
    end subroutine texmod
 
    subroutine texopt(copt,ctype)
      character (len = *), intent (in) :: copt,ctype
    end subroutine texopt
 
    subroutine thkcrv(i)
      integer, intent (in) :: i
    end subroutine thkcrv
 
    subroutine ticks(i,cax)
      integer, intent (in) :: i
      character (len = *), intent (in) :: cax
    end subroutine ticks
 
    subroutine ticlen(i1,i2)
      integer, intent (in) :: i1,i2
    end subroutine ticlen
 
    subroutine ticmod(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine ticmod

    subroutine ticpos(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine ticpos
 
    subroutine tiforg(nx,ny)
      integer, intent (in) :: nx,ny
    end subroutine tiforg
 
    subroutine tifwin(nx,ny,nw,nh)
      integer, intent (in) :: nx,ny,nw,nh
    end subroutine tifwin
 
    subroutine timopt()
    end subroutine timopt
 
    subroutine titjus(copt)
      character (len = *), intent (in) :: copt
    end subroutine titjus
 
    subroutine title()
    end subroutine title
 
    subroutine titlin(cstr,j)
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: j
    end subroutine titlin
 
    subroutine titpos(copt)
      character (len = *), intent (in) :: copt
    end subroutine titpos
 
    subroutine trfco1(xray,n,cfrom,cto)
      real, dimension (:), intent (in out) :: xray
      integer, intent (in) :: n
      character (len = *), intent(in) :: cfrom, cto
    end subroutine trfco1
 
    subroutine trfco2(xray,yray,n,cfrom,cto)
      real, dimension (:), intent (in out) :: xray,yray
      integer, intent (in) :: n
      character (len = *), intent(in) :: cfrom, cto
    end subroutine trfco2
 
    subroutine trfco3(xray,yray,zray,n,cfrom,cto)
      real, dimension (:), intent (in out) :: xray,yray,zray
      integer, intent (in) :: n
      character (len = *), intent(in) :: cfrom, cto
    end subroutine trfco3
 
    subroutine trfdat(ndays,id,im,iy)
      integer, intent (in) :: ndays
      integer, intent (out) :: id,im,iy
    end subroutine trfdat

    subroutine trfrel(x,y,n)
      real, dimension (:), intent (in out) :: x,y
      integer, intent (in) :: n
    end subroutine trfrel
 
    subroutine trfres()
    end subroutine trfres
 
    subroutine trfrot(xang,nx,ny)
      real, intent (in) :: xang
      integer, intent (in) :: nx,ny
    end subroutine trfrot
 
    subroutine trfscl(xscl,yscl)
      real, intent (in) :: xscl,yscl
    end subroutine trfscl
 
    subroutine trfshf(nxshf,nyshf)
      integer, intent (in) :: nxshf,nyshf
    end subroutine trfshf
 
    subroutine triang(xray,yray,n,i1ray,i2ray,i3ray,nmax,ntri)
      real, dimension (:), intent (in) :: xray,yray
      integer, intent (in) :: n,nmax
      integer, dimension (:), intent (out) :: i1ray,i2ray,i3ray
      integer, intent (out) :: ntri 
    end subroutine triang

    subroutine triplx()
    end subroutine triplx
 
    function trmlen(cstr) result (xret)
      character (len = *), intent (in) :: cstr
      real :: xret
    end function trmlen
 
    subroutine txtjus(copt)
      character (len = *), intent (in) :: copt
    end subroutine txtjus

    subroutine unit(i)
      integer, intent (in) :: i
    end subroutine unit
 
    subroutine upstr(cstr)
      character (len = *), intent (in out) :: cstr
    end subroutine upstr
 
    subroutine usrpie(iseg,xdat,xper,nrad,noff,ang,nvbox,idrw,iann)
      integer, intent (in out) :: iseg,nrad,noff,nvbox,idrw,iann
      real,    intent (in out) :: xdat,xper,ang
    end subroutine usrpie
 
    subroutine vang3d(a)
      real, intent (in) :: a
    end subroutine vang3d
 
    subroutine vclp3d(x1,x2)
      real, intent (in) :: x1,x2
    end subroutine vclp3d
 
    subroutine vector(ix1,iy1,ix2,iy2,ivec)
      integer, intent (in) :: ix1,iy1,ix2,iy2,ivec
    end subroutine vector
 
    subroutine vectr3(x1,y1,z1,x2,y2,z2,ivec)
      real, intent (in) :: x1,y1,z1,x2,y2,z2
      integer, intent (in) :: ivec
    end subroutine vectr3
 
    subroutine vfoc3d(x,y,z,cview)
      real, intent (in) :: x,y,z
      character (len = *), intent (in) :: cview
    end subroutine vfoc3d
 
    subroutine view3d(x,y,z,cview)
      real, intent (in) :: x,y,z
      character (len = *), intent (in) :: cview
    end subroutine view3d
 
    subroutine vkxbar(i)
      integer, intent (in) :: i
    end subroutine vkxbar
 
    subroutine vkybar(i)
      integer, intent (in) :: i
    end subroutine vkybar
 
    subroutine vkytit(i)
      integer, intent (in) :: i
    end subroutine vkytit
 
    subroutine vup3d(a)
      real, intent (in) :: a
    end subroutine vup3d
 
    subroutine wgapp(ip,cstr,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgapp
 
    subroutine wgbas(ip,copt,id)
      character (len = *), intent (in) :: copt
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgbas
 
    subroutine wgbox(ip,cstr,isel,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip,isel
      integer, intent (out) :: id
    end subroutine wgbox
 
    subroutine wgbut(ip,cstr,ival,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip,ival
      integer, intent (out) :: id
    end subroutine wgbut
 
    subroutine wgcmd(ip,clab,cstr,id)
      character (len = *), intent (in) :: clab,cstr
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgcmd

    subroutine wgdlis(ip,cstr,isel,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip,isel
      integer, intent (out) :: id
    end subroutine wgdlis

    subroutine wgdraw(ip,id)
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgdraw
 
    subroutine wgfil(ip,clab,cstr,cmask,id)
      character (len = *), intent (in) :: clab,cstr,cmask
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgfil
 
    subroutine wgfin()
    end subroutine wgfin
 
    subroutine wgini(ctype,id)
      character (len = *), intent (in) :: ctype
      integer, intent (out) :: id
    end subroutine wgini
 
    subroutine wglab(ip,cstr,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wglab
 
    subroutine wglis(ip,cstr,isel,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip,isel
      integer, intent (out) :: id
    end subroutine wglis
 
    subroutine wgltxt(ip,clab,cstr,iper,id)
      character (len = *), intent (in) :: clab,cstr
      integer, intent (in)  :: ip,iper
      integer, intent (out) :: id
    end subroutine wgltxt
 
    subroutine wgok(ip,id)
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgok
 
    subroutine wgpbut(ip,cstr,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgpbut
 
    subroutine wgpop(ip,cstr,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgpop
 
    subroutine wgquit(ip,id)
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgquit
 
    subroutine wgscl(ip,cstr,x1,x2,xval,ndez,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip,ndez
      real, intent (in)     :: x1,x2,xval
      integer, intent (out) :: id
    end subroutine wgscl
 
    subroutine wgtxt(ip,cstr,id)
      character (len = *), intent (in) :: cstr
      integer, intent (in)  :: ip
      integer, intent (out) :: id
    end subroutine wgtxt
 
    subroutine widbar(i)
      integer, intent (in) :: i
    end subroutine widbar
 
    subroutine wimage(cfl)
      character (len = *), intent (in) :: cfl
    end subroutine wimage
 
    subroutine winapp(copt)
      character (len = *), intent (in) :: copt
    end subroutine winapp
 
    subroutine window(nx,ny,nw,nh)
      integer, intent (in) :: nx,ny,nw,nh
    end subroutine window
 
    subroutine winfnt(cfnt)
      character (len = *), intent (in) :: cfnt
    end subroutine winfnt
 
    subroutine winid(id)
      integer, intent (out) :: id
    end subroutine winid
 
    subroutine winmod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine winmod

    subroutine winopt(iopt,copt)
      character (len = *), intent (in) :: copt
      integer, intent (in) :: iopt
    end subroutine winopt

    subroutine winsiz(nw,nh)
      integer, intent (in) :: nw,nh
    end subroutine winsiz
 
    subroutine wintit(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine wintit
 
    subroutine world()
    end subroutine world
 
    subroutine wpixel(ix,iy,n)
      integer, intent (in) :: ix,iy,n
    end subroutine wpixel
 
    subroutine wpixls(iray,ix,iy,nw,nh)
      character (len=*), intent (in), dimension (:) :: iray
      integer, intent (in) :: ix,iy,nw,nh
    end subroutine wpixls
 
    subroutine wpxrow(iray,ix,iy,n)
      character (len=*), intent (in), dimension (:) :: iray
      integer, intent (in) :: ix,iy,n
    end subroutine wpxrow
 
    subroutine writfl(nlu,iray,nbyt,istat)
      character (len=*), intent (in), dimension (:) :: iray
      integer, intent (in) :: nlu,nbyt
      integer, intent (out) :: istat
    end subroutine writfl
 
    subroutine wtiff(cfl)
      character (len=*), intent (in) :: cfl
    end subroutine wtiff
 
    subroutine x11mod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine x11mod
 
    function x2dpos(x,y) result (xret)
      real, intent (in) :: x,y
      real :: xret
    end function x2dpos
 
    function x3dabs(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function x3dabs
 
    function x3dpos(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function x3dpos
 
    function x3drel(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function x3drel
 
    subroutine xaxgit()
    end subroutine xaxgit
 
    subroutine xaxis(a,b,o,step,il,cstr,it,ix,iy)
      real, intent (in) :: a,b,o,step
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: il,it,ix,iy
    end subroutine xaxis
 
    subroutine xaxlg(a,b,o,step,il,cstr,it,ix,iy)
      real, intent (in) :: a,b,o,step
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: il,it,ix,iy
    end subroutine xaxlg
 
    subroutine xaxmap(a,b,o,step,cstr,it,iy)
      real, intent (in) :: a,b,o,step
      integer, intent (in) :: it,iy
      character (len = *), intent (in) :: cstr
    end subroutine xaxmap
 
    subroutine xcross()
    end subroutine xcross
 
    subroutine xdraw(xx,yy)
      real, intent (in) :: xx,yy
    end subroutine xdraw
 
    function xinvrs(i) result (xret)
      integer, intent (in) :: i
      real :: xret
    end function xinvrs
 
    subroutine xmove(x,y)
      real, intent (in) :: x,y
    end subroutine xmove
 
    function xposn(x) result (xret)
      real, intent (in) :: x
      real :: xret
    end function xposn
 
    function y2dpos(x,y) result (xret)
      real, intent (in) :: x,y
      real :: xret
    end function y2dpos
 
    function y3dabs(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function y3dabs
 
    function y3dpos(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function y3dpos
 
    function y3drel(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function y3drel
 
    subroutine yaxgit()
    end subroutine yaxgit
 
    subroutine yaxis(a,b,o,step,il,cstr,it,ix,iy)
      real, intent (in) :: a,b,o,step
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: il,it,ix,iy
    end subroutine yaxis
 
    subroutine yaxlg(a,b,o,step,il,cstr,it,ix,iy)
      real, intent (in) :: a,b,o,step
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: il,it,ix,iy
    end subroutine yaxlg
 
    subroutine yaxmap(a,b,o,step,cstr,it,ix)
      real, intent (in) :: a,b,o,step
      integer, intent (in) :: it,ix
      character (len = *), intent (in) :: cstr
    end subroutine yaxmap
 
    subroutine ycross()
    end subroutine ycross
 
    function yinvrs(i) result (xret)
      integer, intent (in) :: i
      real :: xret
    end function yinvrs
 
    function yposn(y) result (xret)
      real, intent (in) :: y
      real :: xret
    end function yposn
 
    function z3dpos(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function z3dpos
 
    subroutine zaxis(a,b,o,step,il,cstr,it,idir,ix,iy)
      real, intent (in) :: a,b,o,step
      integer, intent (in) :: il,it,idir,ix,iy
      character (len = *), intent (in) :: cstr
    end subroutine zaxis
 
    subroutine zaxlg(a,b,o,step,il,cstr,it,idir,ix,iy)
      real, intent (in) :: a,b,o,step
      integer, intent (in) :: il,it,idir,ix,iy
      character (len = *), intent (in) :: cstr
    end subroutine zaxlg
 
    subroutine zbffin()
    end subroutine zbffin
 
    subroutine zbfini(iret)
      integer, intent (out) :: iret
    end subroutine zbfini
 
    subroutine zbflin(x1,y1,z1,x2,y2,z2)
      real, intent (in) :: x1,y1,z1,x2,y2,z2
    end subroutine zbflin
 
    subroutine zbftri(x,y,z,ic)
      real, dimension (3), intent (in) :: x,y,z
      integer, dimension (3), intent (in) :: ic
    end subroutine zbftri
 
    subroutine zscale(a,e)
      real, intent (in) :: a,e
    end subroutine zscale
  end interface
end module dislin
